unit savInit;
interface
uses Windows;
const savModeConfigureStd=1; //right click in explorer and choose configure
      savModeConfigure   =2; //config dialog from screensaver properties dialog
      savModeExecute     =3; //run in fullscreen
      savModePreview     =4; //run in preview window
      savModeSetPwd      =5; //show change password dialog
var SaverMode:Integer; //one of the constants above
    ParamHandle:THandle; //the handle passed on the command line as a parameter
    ConfigParent:hWnd; //the parent window for the config dialog
    //DumpFile:TextFile;
implementation
uses SysUtils;

procedure SetParamHandle;
begin
  try
    ParamHandle:=StrToInt(ParamStr(2));
  except
    ParamHandle:=0;
  end;
end;

procedure GetSaverMode;
var Param1:String;
begin
  ConfigParent:=0; //no modal dialog if not called via /c
  if ParamCount=0 then
    SaverMode:=savModeConfigureStd
  else
  begin
    Param1:=UpperCase(ParamStr(1));
    //AssignFile(DumpFile,'C:\Dump.txt');
    //Append(DumpFile); //File must exist
    //Writeln(DumpFile,Param1);
    //CloseFile(DumpFile);
    Delete(Param1,1,1); //remove the first character, usually a "/" or a "-"
    if Pos('C',Param1)=1 then
    begin //In NT you get /C:windowhandle? so only test if first character is C
      SaverMode:=savModeConfigure;
      ConfigParent:=GetForegroundWindow;
    end
    else
    if (Param1='A') and (ParamCount>1) then
    begin //there must be a window handle
          SaverMode:=savModeSetPwd;
          SetParamHandle;
    end
    else
    if (Param1='P') and (ParamCount>1) then
    begin //there must be a window handle
          SaverMode:=savModePreview;
          SetParamHandle;
    end
    else
    begin //I need to give back the focus the currently active
         SaverMode:=savModeExecute;
         ConfigParent:=GetForegroundWindow;
    end; //window after terminating the full screen saver
  end;
end;

initialization //get cmdline parameters and fill variables
  GetSaverMode;
  //IsLibrary:=True; //Prg acts as DLL, preventing icon showing, leaks memory
end.
